`timescale 1ns/1ns
`define NULL 0
`define MAX_LINE 256
`define EOF 32'hffff_ffff

/* Get lots of error messages */
module test8;
   integer 	filein,r, i1, i2;
   reg 		r1;
   reg [ 7:0] 	r8, s8;
   reg [11:0] 	r12, r13;
 	
   initial
     begin
	$display("***This test will cause a lot of errors which is fine***");
	$display("It tests reading packed data - no separator");

	$display("\n\n------------------------------------------------------------------------");
	$display("Try reading two packed hex from a file with single digits");
	$display("Registers in $getpat_open");
	$display("This will fail.");
	filein = $getpat_open("test8.dec", "h", r8, s8);

	// Loop through the file
	r = $getpat_next(filein);  // Verified
	while (r != `EOF)
	  begin
	     #1 $display("r=%h, s=%h", r8, s8);
	     r = $getpat_next(filein);
	  end
	#1 $display("final r=%h, s=%h", r8, s8);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Try reading two packed hex from a file with single digits");
	$display("Registers in $getpat_next");
	$display("This will fail.");
	filein = $getpat_open("test8.dec", "h");

	// Loop through the file
	r = $getpat_next(filein, r8, s8);  // Verified
	while (r != `EOF)
	  begin
	     #1 $display("r=%h, s=%h", r8, s8);
	     r = $getpat_next(filein, r8, s8);
	  end
	#1 $display("final r=%h, s=%h", r8, s8);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Try reading one packed hex from a file with multiple digits");
	$display("Register in $getpat_open");
	$display("This will fail.");
	filein = $getpat_open("test8.hex", "h", r12);

	// Loop through the file
	r = $getpat_next(filein);  // verified
	while (r != `EOF)
	  begin
	     #1 $display("r=%h", r12);
	     r = $getpat_next(filein);
	  end
	#1 $display("final r=%h", r12);
	$getpat_close(filein);  // verified


	$display("\n\n------------------------------------------------------------------------");
	$display("Try reading one packed hex from a file with multiple digits");
	$display("Register in $getpat_next");
	$display("This will fail.");
	filein = $getpat_open("test8.hex", "h");

	// Loop through the file
	r = $getpat_next(filein, r12);  // verified
	while (r != `EOF)
	  begin
	     #1 $display("r=%h", r12);
	     r = $getpat_next(filein, r12);
	  end
	#1 $display("final r=%h", r12);
	$getpat_close(filein);  // verified


	$display("\n\n------------------------------------------------------------------------");
	$display("Try reading multiple packed hex from a file with not enough digits");
	$display("Register in $getpat_open");
	$display("This will fail.");
	filein = $getpat_open("test8.hex", "h", r12, r13);

	// Loop through the file
	r = $getpat_next(filein);  // verified
	while (r != `EOF)
	  begin
	     #1 $display("r12=%h, r13=%h", r12, r13);
	     r = $getpat_next(filein);
	  end
	#1 $display("final r12=%h, r13=%h", r12, r13);
	$getpat_close(filein);  // verified


        $display("\n\n------------------------------------------------------------------------");
	$display("Try reading multiple packed hex from a file with not enough digits");
	$display("Register in $getpat_next");
	$display("This will fail.");
	filein = $getpat_open("test8.hex", "h");

	// Loop through the file
	r = $getpat_next(filein, r12, r13);  // verified
	while (r != `EOF)
	  begin
	     #1 $display("r12=%h, r13=%h", r12, r13);
	     r = $getpat_next(filein, r12, r13);
	  end
	#1 $display("final r12=%h, r13=%h", r12, r13);
	$getpat_close(filein);  // verified


	$display("\n\n------------------------------------------------------------------------");
	$display("Try reading signed numbers ");
	$display("Register in $getpat_open");
	$display("This will fail in tf_strdelputp, at least in VCS.");
	filein = $getpat_open("test8.sign", "h", i1, i2);

	// Loop through the file
	r = $getpat_next(filein);  // verified
	while (r != `EOF)
	  begin
	     #1 $display("i1=%d, i2=%d", i1, i2);
	     r = $getpat_next(filein);
	  end
	#1 $display("final i1=%d, i2=%d", i1, i2);
	$getpat_close(filein);  // verified


	$display("\n\n------------------------------------------------------------------------");
	$display("The end - at last!");
	$display("\n\n------------------------------------------------------------------------");


	$finish;
     end

endmodule
